// LM35_Temperature ACW
// Joe Pardue May 8, 2009
// based on Tom Igoe's example in the 
// Arduino Serial.print(data) documentation

#include "libACW001.h"

// variable to hold the analog input value
//int analogValue = 0; 
//double millivolts = 0.0;
//float temperature = 0.0;

int whole = 0;
int decimal = 0;

// For the Arduino using 5V, the ADC measures
// 4.9 mV per unit use 49 to avoid floats
#define ADCUnit 49

void showTemp(int ADCin);

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}



void setup()
{
  // begin the serial communication
  //Serial.begin(9600);
  serialBegin(9600);
}

void loop()
{
  // read the analog input on pin 0
  //analogValue = analogRead(0);
  showTemp(analogRead(0));
/*  millivolts = (double)(ADCUnit * (double)analogValue);
  
  // print ADC value
  //Serial.print("TAW LM35 Raw ADC:");
  //Serial.println(analogValue, DEC); 
  printf("ACW LM35 Temperature: %d\n", analogValue);         
  
  // print millivolts
  //Serial.print("TAW LM35 milliVolts:");
  //Serial.print(milliVolts, DEC); 
  //printf("ACW LM35 millivolts: %.0f\n", millivolts);         
 
  // print temperature
  //printf("ACW LM35 Temperature %.0f\n: ",(1.8*(millivolts/10)) + 32 );
  //printf("ACW LM35 Temperature %.0f\n: ",123.456);

	whole = 98;
	decimal = 6;
	printf("986/10 = %d.%d", whole, decimal);
*/
   
  // delay 1 second before the next reading:
  delay(1000); 
}

void showTemp(int ADCValue)
{ 
  // print ADC value
  //Serial.print("1.06 TAW LM35 - raw ADC: ");
  //Serial.print(ADCValue, DEC); 
  printf("1.00 ACW LM35 - raw ADC: %d",ADCValue);

  // make Centigrade
  whole = (ADCValue * ADCUnit)/100;
  decimal = (ADCValue * ADCUnit)%100; 
  
  // round to '0.5'
  if(decimal > 50){ decimal = 0; whole +=1;}
  else decimal = 5;
  
  // print degrees Centigrade
  //Serial.print(" > degree C: ");
  //Serial.print(whole, DEC); 
  //Serial.print('.'); 
  //Serial.print(decimal, DEC); 
  printf(" > degree C: %d.%d",whole,decimal);
  
  // convert Centigrade to Fahrenheit 
  whole = ((9*(ADCValue * ADCUnit))/5)/100;
  decimal = ((9*(ADCValue * ADCUnit))/5)%100;

  // round to '0.5'
  if(decimal > 50){ decimal = 0; whole +=1;}
  else decimal = 5;
   
  // print in degrees Fahrenheit
  //Serial.print(" > degree F: ");
  //whole += 32; // scale it to F
  //Serial.print(whole, DEC); 
  //Serial.print('.'); 
  //Serial.println(decimal, DEC); 
  printf(" > degree F: %d.%d\n",whole+32,decimal);


}
